package xyz.etztech.serverapi;

import xyz.etztech.serverapi.web.IProvider;
import xyz.etztech.serverapi.web.api.PlayerAPI;
import xyz.etztech.serverapi.web.api.QueryAPI;
import xyz.etztech.serverapi.web.api.TPSAPI;
import xyz.etztech.serverapi.web.api.WorldAPI;

import java.util.*;

public class MockProvider implements IProvider {
    List<WorldAPI> worlds;

    public MockProvider() {
        worlds = Arrays.asList(
                new WorldAPI("overworld", 1000, WorldAPI.WEATHER_CLEAR),
                new WorldAPI("nether", 1500, WorldAPI.WEATHER_STORM),
                new WorldAPI("end", 2000, WorldAPI.WEATHER_THUNDER)
        );
    }

    @Override
    public TPSAPI TPS() {
        return new TPSAPI(new LinkedList<>(Arrays.asList(20.0f, 15.0f, 10.0f, 18.0f, 20.0f)));
    }

    @Override
    public WorldAPI world(String name) {
        for (WorldAPI mock : worlds) {
            if (mock.getName().equalsIgnoreCase(name)) {
                return mock;
            }
        }
        return new WorldAPI("unknown", 0, WorldAPI.WEATHER_CLEAR);
    }

    @Override
    public List<WorldAPI> worlds() {
        return worlds;
    }

    @Override
    public Set<PlayerAPI> bans() {
        return new HashSet<>(Arrays.asList(
                new PlayerAPI("Badzelia", "bf0446a8-9695-4c41-aa4c-7ff45bfd1171"),
                new PlayerAPI("LessThanZeroSD", "fe7e8413-2570-4588-9203-2b69ff188bc3"),
                new PlayerAPI("Vakbuttzel", "7afbf663-2bf0-49ef-915f-22e81b298d17")
        ));
    }

    @Override
    public Set<PlayerAPI> players() {
        return new HashSet<>(Arrays.asList(
                new PlayerAPI("Etzelia", "bf0446a8-9695-4c41-aa4c-7ff45bfd1171"),
                new PlayerAPI("Zero", "fe7e8413-2570-4588-9203-2b69ff188bc3"),
                new PlayerAPI("Vak", "7afbf663-2bf0-49ef-915f-22e81b298d17")
        ));
    }

    @Override
    public QueryAPI query() {
        return new QueryAPI("Mock", "0.0.1", "Hello, world!", 0, 100);
    }

    @Override
    public void log(String message) {
        System.out.println(message);
    }
}
